from django.shortcuts import render,redirect
from rest_framework.response import Response
from rest_framework import status
from rest_framework.views import APIView
from .models import *
from .serializers import *
from django.contrib.auth.decorators import login_required,user_passes_test
from django.utils.decorators import method_decorator
import json
from brmainApp.models import ActiveHourSlot
# Create your views here.
# class ClinicsApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_clinics'), login_url='/auth/login/'))
#     def get(self,request):
#         #if not getClinicId(request) : return redirect('/main/login/')
#         all_clinics =Clinic.objects.all()
#         all_clinics =ClinicSerializer(all_clinics,many=True)
#         #complaints = Complaint.objects.all()
#         return render(request,"Clinic/clmainApp/clinics.html",
#         {
#             "all_clinics":all_clinics.data,
#             #"complaints":complaints,
#         'activePage':'Clinics'})
    
# class ClinicTypesApi(APIView):
#     @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_clinictypes'), login_url='/auth/login/'))
#     def get(self,request):
#         #if not getClinicId(request) : return redirect('/main/login/')
#         all_clinic_types =ClinicType.objects.all()
#         all_clinic_types =ClinicTypeSerializer(all_clinic_types,many=True)
#         complaints = Complaint.objects.all()
#         return render(request,"Clinic/clmainApp/clinic_types.html",
#         {
#             "all_clinic_types":all_clinic_types.data,
#             "complaints":complaints,
#         'activePage':'ClinicTypes'})
        
# class ClinicComplaintsApi(APIView):
#     #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_Complaint'), login_url='/auth/login/'))
#     def get(self,request,clinic_id):
#         #if not getClinicId(request) : return redirect('/main/login/')
#         clinic_complaints_ids =ClinicComplaint.objects.filter(clinic_id=clinic_id).values_list('complaint_id',flat=True)
#         return Response(clinic_complaints_ids,status=status.HTTP_200_OK)
    
#     def post(self,request,clinic_id):
#         #if not getClinicId(request) : return redirect('/main/login/')
#         data = request.data
#         selected_complaints = data.getlist('complaints[]')
#         clinic_complaints = []
#         if selected_complaints :
#             for complaint in selected_complaints :
#                 clinic_complaints.append({"complaint":complaint ,"clinic":clinic_id , "created_by":request.user.id })
#         serializer= ClinicComplaintSerializer(data=clinic_complaints,many=True)
#         if serializer.is_valid():
#             ClinicComplaint.objects.filter(clinic_id=clinic_id).delete()
#             serializer.save()
#             return Response(serializer.data,status=status.HTTP_201_CREATED)
#         else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

class ClinicTypeComplaintsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_complainttypes'), login_url='/auth/login/'))
    def get(self,request,clinic_type_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        clinic_type_complaints_ids =ClinicTypeComplaint.objects.filter(clinic_type_id=clinic_type_id).values_list('complaint_id',flat=True)
        return Response(clinic_type_complaints_ids,status=status.HTTP_200_OK)
    
    def post(self,request,clinic_type_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        selected_complaints = data.getlist('complaints[]')
        clinic_type_complaints = []
        if selected_complaints :
            for complaint in selected_complaints :
                clinic_type_complaints.append({"complaint":complaint ,"clinic_type":clinic_type_id , "created_by":request.user.id })
        serializer= ClinicTypeComplaintSerializer(data=clinic_type_complaints,many=True)
        if serializer.is_valid():
            ClinicTypeComplaint.objects.filter(clinic_type=clinic_type_id).delete()
            serializer.save()
            return Response(serializer.data,status=status.HTTP_201_CREATED)
        else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)


class ClinicBranchesApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_branches'), login_url='/auth/login/'))
    def get(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        #clinic = Clinic.objects.get(id=clinic_id)
        clinic_branches =Branch.objects.all()
        hourSlots = HourSlot.objects.filter(is_active=True).values().order_by('order')
        #clinic_branches =Branch.objects.filter(clinic_id=clinic_id)
        #locations = Location.objects.all()
        return render(request,"Clinic/clbranchApp/clinic_branches.html",{
            "clinic_branches":clinic_branches,
            "hourSlots":hourSlots,
            #"locations":locations,
            #"clinic":clinic,
            'activePage':'ClinicBranches'})
    
    def post(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        data._mutable = True
        data.update({"created_by":request.user.id,"reports_code":"branch_general"})
        serializer= BranchSerializer(data=data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data,status=status.HTTP_201_CREATED)
        else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

class BranchApi(APIView):
    def get_object(self,pk):
        try:
            return Branch.objects.get(pk=pk)
        except Branch.DoesNotExist:
            return None    
        
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_branches'), login_url='/auth/login/'))        
    def get(self,request,pk): 
        Obj=self.get_object(pk)
        if Obj :
            serializer= BranchSerializer(Obj)
            return Response(serializer.data,status=status.HTTP_200_OK)
        else : return Response(status=status.HTTP_404_NOT_FOUND)

    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.change_branch'), login_url='/auth/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        serializer= BranchSerializer(obj,data=request.data,partial=True)
        if serializer.is_valid():
            serializer.save()
            return Response(status=status.HTTP_200_OK)
        else : return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.delete_branch'), login_url='/auth/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                ActiveHourSlot.objects.filter(branch_id=pk).delete()
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)

class BranchLocationsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('ClManagement.view_branchLocations'), login_url='/auth/login/'))
    def get(self,request,branch_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        clinic_locations_ids =BranchCoverage.objects.filter(branch_id=branch_id).values_list('location_id',flat=True)
        return Response(clinic_locations_ids,status=status.HTTP_200_OK)
    
    def post(self,request,branch_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        selected_locations = data.getlist('locations[]')
        branch_locations = []
        if selected_locations :
            for location in selected_locations :
                branch_locations.append({"location":location ,"branch":branch_id , "created_by":request.user.id })
        serializer= BranchCoverageSerializer(data=branch_locations,many=True)
        if serializer.is_valid():
            BranchCoverage.objects.filter(branch_id=branch_id).delete()
            serializer.save()
            return Response(serializer.data,status=status.HTTP_201_CREATED)
        else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

class LocationBranchesApi(APIView):
    def post(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        clinic_id = data["clinic_id"]
        location_id = data["location_id"]
        clinic_branches = Branch.objects.filter(clinic_id=clinic_id)
        branches_ids = []
        branches = []
        obj = BranchCoverage.DoesNotExist
        for branch in clinic_branches:
            try:
                obj = BranchCoverage.objects.get(location_id=location_id, branch_id=branch.id)
            except BranchCoverage.DoesNotExist:
                obj = None

            if obj:
                obj = BranchCoverageSerializer(obj)
                branches_ids.append(obj.data["branch"])
                
        for id in branches_ids:
            branches.append(Branch.objects.get(pk=id))
        
        branches = BranchSerializer(branches, many=True)
        return Response(branches.data,status=status.HTTP_200_OK)
class BranchFixedScheduleApi(APIView):
    def get_object(self,pk):
        try:
            return Branch.objects.get(pk=pk)
        except Branch.DoesNotExist:
            return None    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_Complaint'), login_url='/auth/login/'))
    def get(self,request,branch_id): 
        branch=self.get_object(branch_id)
        if not branch : return redirect('clauthApp:home')
        weekDays = WeekDay.objects.filter(is_active=True).order_by('order').values()
        hourSlots = HourSlot.objects.filter(is_active=True).values().order_by('order')
        branchDays = BranchDay.objects.filter(branch_id = branch_id).values('id' , 'day')
        branch_workdays_ids = branchDays.values_list('day',flat=True)#el ayam
        branchDays_ids = branchDays.values_list('id',flat=True)# ids of days
        branchDaySlot_ids = BranchDaySlot.objects.filter(branch_day_id__in =branchDays_ids).values_list('slot',flat=True)
        #for wd in weekDays : wd["is_working"] = True if wd["id"] in branch_workdays_ids else False
        branch_data_days =[]
        for wd in weekDays :
            obj={}
            branch_day  =  branchDays.filter(day_id=wd["id"])
            if branch_day : branch_day_id = branch_day.first()['id']
            else : branch_day_id = 0
            obj["day"] ={"id":wd["id"],"name":wd["name"],"is_working":True if wd["id"] in branch_workdays_ids else False}
            obj["slots"]=[]
            branchDaySlot_ids_day = branchDaySlot_ids.filter(branch_day_id= branch_day_id)
            for hS in hourSlots :
                slotObj ={"id":hS["id"] ,"is_working": True if hS["id"] in branchDaySlot_ids_day else False }
                obj["slots"].append(slotObj)
            branch_data_days.append(obj)
    
        #branchDaysSlots = BranchDaySlot.objects.filter(branch_id = pk).values('id' , 'day')
        #BranchDaySlot.objects.filter(id)
        return render(request,"Clinic/clmainApp/branch_fixed_schedule.html",{
                    "branch":branch,
                    "branch_data_days":branch_data_days,
                    "hourSlots":hourSlots,
                    'activePage':'BranchFixedSchedule'})    
    #     return Response(serializeobj.data,status=status.HTTP_200_OK)
    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_Doctor'), login_url='/auth/login/'))        
    def post(self,request,branch_id):
        branch=self.get_object(branch_id)
        if not branch : return redirect('clauthApp:home')
        data = request.data
        days_data_json = data['days_data'] 
        days_data = json.loads(days_data_json)
        if days_data : 
            branch_days_objs  = BranchDay.objects.filter(branch=branch)
            branch_days_ids = branch_days_objs.values_list('id',flat=True)
            dds = BranchDaySlot.objects.filter(branch_day__in = branch_days_ids)
            dds.delete()
            branch_days_objs.delete()
            for obj in days_data :
                branchDay = BranchDay.objects.create(branch=branch,day_id=obj["day"])
                for slot_id in obj["slots"]:
                    BranchDaySlot.objects.create(branch_day=branchDay,slot_id=slot_id)
        return Response(status=status.HTTP_200_OK)